<script setup lang="ts">
import AForm from '@/components/AForm/index.vue'
import { FormConfigType } from '@/components/AForm/type'
import { ToolbarConfigType } from '@/components/AToolbar/type'
import { ColumnConfigType } from '@/components/ATable/type'
import { StrAnyObj, StrAnyObjArr } from '@/typings'
import { useHandleData } from '@/utils/useHandleData'
import {
  getPageApi,
  getDetailApi,
  addApi,
  editApi,
  deleteApi
} from '@/api//business/corporation/corporation'

const queryRef = ref<InstanceType<typeof AForm>>()
const formRef = ref<InstanceType<typeof AForm>>()

const showQuery = ref<boolean>(true)
const selectKeys = ref<string[]>([])
const pageTotal = ref<number>(0)

const queryData = ref<StrAnyObj>({ pageNum: 1, pageSize: 10 })
const tableData = ref<StrAnyObjArr>([])
const formData = ref<StrAnyObj>({})

const dialogTitle = ref<string>('')
const dialogVisible = ref<boolean>(false)

const queryConfig: FormConfigType[] = [
  {
    type: 'input',
    prop: 'name',
    label: '公司名称'
  },
  {
    type: 'select',
    prop: 'type',
    label: '企业类型',
    dict: 'corporation_type'
  },
  {
    type: 'input',
    prop: 'uscCode',
    label: '统一信用代码'
  }
]

const toolbarConfig: ToolbarConfigType[] = [
  {
    common: 'search',
    click() {
      queryData.value.pageNum = 1
      getPage()
    }
  },
  {
    common: 'reset',
    click() {
      queryRef.value?.resetFields()
      getPage()
    }
  },
  {
    common: 'add',
    click() {
      dialogVisible.value = true
      dialogTitle.value = '新增'
    }
  },
  {
    common: 'delete',
    disabled() {
      return selectKeys.value.length == 0
    },
    click() {
      handleRemove(selectKeys.value)
    }
  }
]

const columnConfig: ColumnConfigType[] = [
  {
    prop: 'name',
    label: '公司名称'
  },
  {
    prop: 'type',
    label: '企业类型',
    dict: 'corporation_type'
  },
  {
    prop: 'uscCode',
    label: '统一信用代码'
  },
  {
    prop: 'legalPersonName',
    label: '法定代表人'
  },
  {
    prop: 'registeredCapital',
    label: '注册资本'
  },
  {
    prop: 'taxpayerQualification',
    label: '纳税人资质'
  },
  {
    prop: 'corporationNumber',
    label: '公司电话'
  },
  {
    width: 250,
    handleConfig: [
      {
        common: 'update',
        click(row) {
          dialogVisible.value = true
          dialogTitle.value = '编辑'
          getDetailApi({ id: row.id }).then((resp: StrAnyObj) => {
            formData.value = resp
          })
        }
      },
      {
        common: 'delete',
        click(row) {
          handleRemove([row.id])
        }
      }
    ]
  }
]

const formConfig: FormConfigType[] = [
  {
    type: 'input',
    prop: 'name',
    label: '公司名称',
    rule: [{ required: true, message: '公司名称不能为空', trigger: 'blur' }]
  },
  {
    type: 'select',
    prop: 'type',
    label: '企业类型',
    dict: 'corporation_type',
    rule: [{ required: true, message: '企业类型不能为空', trigger: 'blur' }]
  },
  {
    type: 'input',
    prop: 'uscCode',
    label: '统一信用代码',
    rule: [{ required: true, message: '统一信用代码不能为空', trigger: 'blur' }]
  },
  {
    type: 'input',
    prop: 'legalPersonName',
    label: '法定代表人'
  },
  {
    type: 'input',
    prop: 'registeredCapital',
    label: '注册资本'
  },
  {
    type: 'input',
    prop: 'taxpayerQualification',
    label: '纳税人资质'
  },
  {
    type: 'input',
    prop: 'corporationNumber',
    label: '公司电话'
  },
  {
    type: 'input',
    itemType: 'textarea',
    prop: 'remark',
    label: '备注',
    rows: 3
  }
]

onMounted(() => {
  getPage()
})

function getPage() {
  getPageApi(queryData.value).then((resp) => {
    tableData.value = resp.records
    pageTotal.value = resp.total
  })
}

function tableSelectionChange(item: StrAnyObjArr) {
  selectKeys.value = item.map((item) => item.id)
}

function formSubmit() {
  formRef.value?.validate(() => {
    if (formData.value.id) {
      editApi(formData.value).then(() => {
        dialogVisible.value = false
        ElMessage.success('修改成功')
        getPage()
      })
    } else {
      addApi(formData.value).then(() => {
        dialogVisible.value = false
        ElMessage.success('新增成功')
        getPage()
      })
    }
  })
}

function formClosed() {
  formRef.value?.resetFields()
}

function handleRemove(idList: string[]) {
  useHandleData('是否确认删除？', () => {
    deleteApi({ idList }).then(() => {
      ElMessage.success('删除成功')
      getPage()
    })
  })
}
</script>

<template>
  <div>
    <el-card v-if="showQuery">
      <a-form ref="queryRef" v-model="queryData" :config="queryConfig" :span="6"> </a-form>
    </el-card>

    <a-table
      selection
      :data="tableData"
      :page-total="pageTotal"
      :toolbar-config="toolbarConfig"
      :column-config="columnConfig"
      v-model:showQuery="showQuery"
      v-model:page-num="queryData.pageNum"
      v-model:page-size="queryData.pageSize"
      @page-num-change="getPage"
      @page-size-change="getPage"
      @selection-change="tableSelectionChange"
    >
    </a-table>

    <a-dialog
      v-model="dialogVisible"
      :title="dialogTitle"
      @submit="formSubmit"
      @closed="formClosed"
    >
      <a-form ref="formRef" v-model="formData" :config="formConfig" :span="24"> </a-form>
    </a-dialog>
  </div>
</template>
